/*
 * Demo application for libsub header file
 * Copyright (C) 2008-2009 Alex Kholodenko <sub20@xdimax.net>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.0 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

/*
*-------------------------------------------------------------------
* Version: $Id: sub_upd.h,v 1.4 2010/07/24 21:34:21 avr32 Exp $
*-------------------------------------------------------------------
*/
#ifndef SUB_UPD_H_INCLUDED
#define SUB_UPD_H_INCLUDED


/*
*------------------------------------------------------------------------------
*                               types
*------------------------------------------------------------------------------
*/

/*
*------------------------------------------------------------------------------
*                               defines
*------------------------------------------------------------------------------
*/

/* Version */
#define VERSION_STR     "XDimax LTD, V%s, %s %s\n"
#define VERSION_INFO    "0.1.3"
#define APP_NAME        "sub_upd"
#define XPRINT_VERSION do{printf( VERSION_STR, VERSION_INFO, __DATE__, __TIME__ );}while(0);

  
/*
* Usage Descriptor
*/
option_descriptor_t usage_descriptor[]={
    {   
        'h', "help", "", 
        "Print this message and exit",
#define HELP_CMD_CASE           0
        HELP_CMD_CASE
    },

    {
        'v', "version", "",
        "Print version and exit",
#define VER_CMD_CASE            1
        VER_CMD_CASE
    },

    {
        'l', "list", "",
        "List connected devices and exit",
#define LIST_CMD_CASE            2
        LIST_CMD_CASE
    },

    {
        'n', "non_interac", "",
        "Non-interactive mode(do not ask)",
#define NON_INT_CMD_CASE            3
        NON_INT_CMD_CASE
    },


    {
        'i', "image", "filename",
        "Update firmware",
#define UPD_CMD_CASE				4
        UPD_CMD_CASE
    },
};

/*
*------------------------------------------------------------------------------
*                               Global Variables
*------------------------------------------------------------------------------
*/


/*
*------------------------------------------------------------------------------
*                               MACRO
*------------------------------------------------------------------------------
*/

/*
*------------------------------------------------------------------------------
*                               Functions
*------------------------------------------------------------------------------
*/

#endif /*H_INCLUDED*/

